config/routes.rb
Programadorpoliglota::Application.routes.draw do

  
  match 'tweets' => 'home#index', :as => :tweets
  match 'apoie' => 'home#support', :as => :support
  
  match 'tweets/see_more/:tag_group/:page' => 'home#see_more', :as=>:see_more

  root :to => "home#index"

end

app/models/link.rb
class Link < ActiveRecord::Base
  belongs_to :tag_group
  
  def self.create_from(tweet)
    urls = scan_for_urls(tweet.text)
    logger.debug "Found #{urls.size} urls for the tweet: #{tweet.id}"
    urls.each do |url|
      extractor = URLInformationExtractor.new url
      logger.debug "The url at the tweet is: #{url} ... preparing to unwrap it"

      full_url = extractor.unwrap
      logger.debug "The full url found is: #{full_url}"
      title = extractor.title(full_url)
      logger.debug "The title of url found is: #{title}"

      link = Link.create :url=>full_url, :tag_group=>tweet.tag_group, :title=>title
      tweet.tag_group.links << link
    end
  end
  
  def self.most_popular_for(tag_group)
      Link.select("count(*) as quantidade, url, title").where(["created_at > ? AND tag_group_id = ?", 7.days.ago, tag_group.id]).group("url").order("quantidade desc").limit(3).all
  end

  def self.scan_for_urls(text)
    text.scan(/http[s]?:\/\/+[\w\d:\#\@\%\/;\$\(\)\~\_\?\+\-\=\\\.&]+/)
  end  
end

app/models/retweeted_user.rb
class RetweetedUser < ActiveRecord::Base
  belongs_to :tag_group
  belongs_to :user 
  
  def self.extract_retweets_from(tweet)
    retweeteds = scan_for_retweeteds(tweet.text)
    retweeteds.each do |r|
      user = User.find_or_create_by_twitter_id(r)
      rt_user = RetweetedUser.create :tag_group_id=>tweet.tag_group.id, :user_id=>user.id
    end
  end
  
  def self.scan_for_retweeteds(text)
    text.scan(/RT[\s]+@([^:\s]+)/).collect {|v| v[0]}
  end
  
  def self.most_retweeted_for(tag_group)
    where('tag_group_id = ? and created_at > ?', tag_group.id, 7.days.ago).includes(:user).group('user_id').order('count(user_id) DESC').limit(5)
  end
end

app/models/tag.rb
class Tag < ActiveRecord::Base
  belongs_to :tag_group
end

app/models/tag_group.rb
class TagGroup < ActiveRecord::Base
  has_many :tags
  has_many :tweets
  has_many :links
  has_many :retweeted_users
  has_many :communities
end

app/models/tweet.rb
class Tweet < ActiveRecord::Base
  belongs_to :tag_group
  belongs_to :user
  TWEETS_PER_PAGE = 4

  def self.last_tweets_for(tag_group, hash={})
    options = {:page=>1}
    options.merge! hash
    offset = (options[:page] - 1) * TWEETS_PER_PAGE
    joins(:tag_group).where(:tag_groups=>{:name=>tag_group.name}).includes(:user).limit(TWEETS_PER_PAGE).offset(offset).order('date DESC')
  end

  def self.amount_of_tweets_for(tag_group)
    where(:tag_group_id=>tag_group.id).count
  end

  def self.last_tweet_from_group(tag_group) 
    where(:tag_group_id=>tag_group.id).order('date').last
  end

  def self.already_exists_in_group?(raw_tweet, tag_group)
    where(:tweet_id=>raw_tweet.id, :tag_group_id=>tag_group.id).exists?
  end
end

app/models/tweet_observer.rb
class TweetObserver < ActiveRecord::Observer
  def after_create(obj)
    clean_cache
  end

  def clean_cache
    file_name = 'public/index.html'
    if File.exists? file_name
      File.delete file_name
    end
  end
end

app/models/tweets_retrieval_job.rb
class TweetsRetrievalJob
  def import_all_groups_tweets
    start = Time.now
    tag_groups = TagGroup.all

    tag_groups.each do |tag_group|
      import_tweets_of tag_group
    end

    Rails.logger.info "Tweets added in #{Time.now - start}"
  end

  def import_tweets_of(tag_group)
    twitter_queries = TwitterQueryBuilder.build_queries_for_group(tag_group)
    twitter_queries.each do |query|
      query.each do |tweet|
        import_raw_tweet_to_group(tweet, tag_group)
      end
    end
  end

  def import_raw_tweet_to_group(raw_tweet, tag_group)
    unless Tweet.already_exists_in_group?(raw_tweet, tag_group)
      user = User.create_user_if_not_exists raw_tweet
      new_tweet = Tweet.create :text=>raw_tweet.text, :date=>raw_tweet.created_at, :tag_group=>tag_group, :tweet_id=>raw_tweet.id
      new_tweet.user = user
      tag_group.tweets << new_tweet

      RetweetedUser.extract_retweets_from(new_tweet)
      Link.create_from(new_tweet)
      Rails.logger.debug "Tweet ##{raw_tweet.id} created for the #{tag_group.name} group"
    else
      Rails.logger.debug "Tweet ##{raw_tweet.id} already exists for the #{tag_group.name} group, therefore skipping it"
    end 
  end
end

app/models/twitter_query_builder.rb
class TwitterQueryBuilder
  def self.build_queries_for_group(tag_group)
    tag_group.tags.collect do |tag|
      Rails.logger.debug "Accessing twitter API and searching for #{tag.name}"
      last_tweet = Tweet.last_tweet_from_group tag_group
      twitter_query = Twitter::Search.new(tag.query).lang('pt').per_page(100)
      twitter_query = twitter_query.since(last_tweet.tweet_id.to_i) if last_tweet
      twitter_query
    end
  end
end

app/models/url_information_extractor.rb
require 'logger'

class URLInformationExtractor
  def initialize(url)
    @url = url
  end
  
  def unwrap
    begin
      location = Net::HTTP.get_response(URI.parse(@url)).to_hash['location']
      location == nil ? @url : location[0]
    rescue
      @url
    end
  end
  
  def title(default_title = nil)
    begin
      agent = Mechanize.new
      agent.user_agent_alias = 'Mac Safari'
      agent.get(@url).title
    rescue Exception => e
      logger = Logger.new('log/links.log')
      title = default_title || @url
      logger.error "Problems extracting title: #{e}. Will use #{title} as the title"
      title
    end
  end
end

app/models/user.rb
class User < ActiveRecord::Base
  has_many :tweets
  has_many :retweeted_users
  
  def self.create_user_if_not_exists(tweet)
    twitter_id = tweet.from_user
    user = where(:twitter_id => twitter_id).first
    if user
      user.image_url = tweet.profile_image_url
      user.save
    else
      user = User.create :twitter_id=>twitter_id, :image_url=>tweet.profile_image_url
    end
    user
  end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  protect_from_forgery
end

app/controllers/home_controller.rb
class HomeController < ApplicationController
  caches_page :index, :support

	before_filter :load_tag_groups, :only=> [:support,:index]
	
  def index
    page = 1
    @tweets = {}
    @links = {}
    @retweeted_users = {}
    load_tweets_and_links_for @tag_groups, page
  end

  def see_more
    @page = params[:page].to_i ||= 1
    @tag_group = TagGroup.find(params[:tag_group].to_i)
    @tweets = retrieve_tweets_for @tag_group, @page
    has_more_pages(@tag_group)

    render :layout => false
  end

  def support
  end

  private

  def has_more_pages(tag_group)
    total_tweets = Tweet.amount_of_tweets_for @tag_group
    @has_more_pages = (total_tweets > @page * Tweet::TWEETS_PER_PAGE)  
  end
  
  def load_tweets_and_links_for(tag_groups, page)
    tag_groups.each do |tag_group|
      @tweets[tag_group.name] = retrieve_tweets_for tag_group, page
      @retweeted_users[tag_group.name] = RetweetedUser.most_retweeted_for(tag_group)
      @links[tag_group.name] = Link.most_popular_for tag_group
    end
  end  
  
  def retrieve_tweets_for(tag_group, page)
    Tweet.last_tweets_for tag_group, :page=> page
  end  

  def load_tag_groups
	@tag_groups = TagGroup.all
	@tag_g = @tag_groups.sort {|a,b| a[:name].length <=> b[:name].length}  #organiza pelo comprimento do nome para caber no cabeçalho do site.
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/home_helper.rb
module HomeHelper
  def next_page_link(page, tag_group)
    link_to 'Ver mais', see_more_url(:page=>page + 1, :tag_group=>tag_group), :class=>'ver_mais btnMoreTweets'
  end
  
  def previous_page_link(page, tag_group)
    link_to 'Anteriores', see_more_url(:page=>page - 1, :tag_group=>tag_group), :class=>'ver_mais btnMoreTweets'
  end
  
  def image_url_of(user)
    user.image_url ||= '/images/default_twitter.png'
  end
  
  def replace_text_links_for_clickable_links(text)
    text.sub(/http[s]?:\/\/+[\w\d:\#\@\%\/;\$\(\)\~\_\?\+\-\=\\\.&]+/) { |link| "<a href='#{link}' target='_blank'>#{link}</a>" }
  end
  
  def about_link(id)
    link_to raw('<span>Apoie o <br /> movimento</span>'), about_path, :id=>id
  end  
end

app/views/home/_tweet_information.html.erb
<li>
	<a target="blank" href="http://www.twitter.com/<%=tweet.user.twitter_id%>">
    <img src='<%= image_url_of(tweet.user) %>' style="width:48px; height:48px;">
  </a>
  <p style="min-height:100px;">
	<span class='tweet_text'>
    	<a target="blank" href="http://www.twitter.com/<%=tweet.user.twitter_id%>"><%= tweet.user.twitter_id %></a> 
    	<%= raw(replace_text_links_for_clickable_links tweet.text) %>
	</span>
	<br/>
	<span class="twitter_time">
    	<a href='<%= "http://www.twitter.com/#{tweet.user.twitter_id}/status/#{tweet.tweet_id}"%>'><small>twittado em <%= tweet.date.strftime('%d/%m/%Y %H:%M') %></small></a>
	</span>
  </p>
</li>

app/views/home/index.html.erb
<div class="center1">
	<div id="contentPP" class="size1">
	  <% @tag_groups.each do |tag_group| %>
		<div class="dragWrap" id="wraplang0<%=tag_group.id %>">
			<div class="size3 bSpace01 fLeft lang0<%=tag_group.id %>" id="lang0<%=tag_group.id %>">
			  <h2 class="headerLang"><%=tag_group.name%></h2>
			  <div class="shapeLang">
				<div id="hideLang"><a href="#" title="Esconder esta linguagem" class="hide">
					<img src="images/hide_button.gif" alt="Botão de esconder linguagem"/></a>
				</div>
				<div class="linkLang">
				  <p class="dragBar">::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::</p>
				  <h3>Top links</h3>
				  <ul>
				    <% @links[tag_group.name].each do |l| %>
				      <li style="min-height:30px;">
				        <a target="blank" href="<%= l.url %>"><%= truncate(l.title, :length=>80, :separator=>' ') %></a>
				      </li>
				    <% end%>
				  </ul>
				</div>
				<ul class="newsLang">
				  <% @tweets[tag_group.name].each do |t| %>
				    <%= render :partial=>'tweet_information', :locals=>{:tweet => t} %>
				  <% end %>
				</ul>
				<div class='bloco_ver_mais'> 
				  <%= next_page_link(1, tag_group.id) %>
				</div>
				<div class="retweetedPeopleLang">
				  <h3>Mais retweetados em <%=tag_group.name %></h3>
				  <% @retweeted_users[tag_group.name].each do |ru| %>
				    <a target="blank" href="http://www.twitter.com/<%=ru.user.twitter_id%>">
				      <%= image_tag image_url_of(ru.user), :class=>'twitter_photo' %>
				    </a>
				  <% end %>
				</div>
			  </div>
			</div>
		</div>
	  <% end %>
	</div>
	<a class="moreLangOptions size1_null" href="http://twitter.com/?status=@progpoliglota"><span>Alguma linguagem faltando? Solicite mais linguagens.</span></a>
</div>

app/views/home/see_more.html.erb
	<ul class="newsLang">
	<% @tweets.each do |t| %>					
		<%= render :partial=>'tweet_information', :locals=>{:tweet => t} %>	
	<% end %>
	</ul>
  <div class='bloco_ver_mais'> 
	  <%if @has_more_pages%>
		  <%= next_page_link(@page, @tag_group) %>
	  <% end %>
	  <% if @page >= 2 %>
		  <%= previous_page_link(@page, @tag_group) %>
    <% end%>
 </div>

app/views/home/support.html.erb
<div id="supportPP">
	<h2>Sobre o movimento</h2>
	<p>
		A idéia do movimento não é original: há muito tempo tem se discutido
		a importância do conhecimento de mais de uma plataforma/linguagem,
		além da inevitabilidade do seu sistema acabar por ser heterogêneo.
		Neal Ford foi um dos primeiros a escrever sobre este <a href="http://memeagora.blogspot.com/2006/12/polyglot-programming.html" target="_blank">assunto</a>.
	</p>
	<p>
		O site surgiu dentro da <a href="http://www.caelum.com.br/">Caelum</a>, para que pudessemos
		acompanhar o que a comunidade brasileira de desenvolvedores está estudando e conversando a respeito.
	</p>
	<p>
		O início da implementação do site é de <a target="_blank" href="http://www.twitter.com/adrianoalmeida7">Adriano Almeida</a> e <a  target="_blank" href="http://www.twitter.com/lucasas">Lucas Souza</a>,
		com design do Tiago Allen. Você pode colaborar com o projeto fazendo o fork dele no github: 
		<a href="http://github.com/caelum/programadorpoliglota/">http://github.com/caelum/programadorpoliglota/</a>, onde já existem issues 
		cadastradas.
	</p>
	<p>
		Nossos agradecimentos: <a href="https://github.com/emerleite" target="_blank">Emerson Macedo</a>, <a href="https://github.com/edgarlatorre" target="_blank">Edgar Latorre</a> e ao <a href="https://github.com/marcofognog" target="_blank">Marco Antonio</a> que contribuiram com forks para o projeto.
	</p>
	<br/>
	<h2>Apoie o movimento</h2>
	<p>
		Gosta de muitas linguagens? Está estudando as linguagens funcionais antigas que influenciam muitas de hoje em dia?
	</p>
	<p>
		Basta você twitar com uma hashtag da linguagem ou assunto relacionado, ou mesmo com #progpoliglota, que sua mensagem aparecerá aqui.
		Os links e usuários mais retwitados também ganham destaque no site.
	</p>
	<p>
		Você também pode apoiar o movimento linkando o site em seu blog e comitando no projeto no <a target="_blank" href="https://github.com/caelum/programadorpoliglota">github</a>.
	</p>
	<br/>
	<h3>Coloque o banner do movimento em seu site ou blog</h3>
    <p>
      <a href="http://www.programadorpoliglota.com.br">
        <%= image_tag('programador-poliglota-120x60.gif', :alt=>'Eu apoio esta campanha', :width=>120, :height=>60) %>
	    </a>
	</p>
    <pre>
&lt;a href=&quot;http://www.programadorpoliglota.com.br&quot;&gt;
&lt;img height=&quot;60&quot; width=&quot;120&quot; 
src=&quot;<%= root_url%>images/programador-poliglota-120x60.gif&quot; 
alt=&quot;Eu apoio esta campanha&quot; /&gt;&lt;/a&gt;
    </pre>
	<p>
	    <a href="http://www.programadorpoliglota.com.br">
        <%= image_tag('programador-poliglota-120x60-team.gif', :alt=>'Minha empresa apoia esta campanha', :width=>120, :height=>60) %>
	    </a>
	</p>
    <pre>
&lt;a href=&quot;http://www.programadorpoliglota.com.br&quot;&gt;
&lt;img height=&quot;60&quot; width=&quot;120&quot; 
src=&quot;<%= root_url%>images/programador-poliglota-120x60-team.gif&quot; 
alt=&quot;Minha empresa apoia esta campanha&quot; /&gt;&lt;/a&gt;
    </pre>
</div>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
  <title>Programador Poliglota</title>
  <%= stylesheet_link_tag :all %>
  <%= javascript_include_tag 'http://ajax.googleapis.com/ajax/libs/jquery/1.4.2/jquery.min.js',
		'jquery.cookie.js','https://ajax.googleapis.com/ajax/libs/jqueryui/1.8.7/jquery-ui.min.js','application.js' %>
  <%= csrf_meta_tag %>
</head>
<body>
  <div id="headerWrap">
    <a id="twitterPageTurn" href="http://twitter.com/progpoliglota" target="_blank">
      <span>Siga-nos no twitter!</span>
    </a>
	  <div id="headerPP" class="size1">
		  <ul id="menu">
        	<li><a id="menuHomePP" href="<%= root_url %>"><span>Programador <br /> Poliglota</span></a></li>
	        <li><a id="menuApoiePP" href="<%= support_url %>"><span>Apoie o <br />movimento</span></a></li>    
      </ul>
	<div>
		<ul id="menuLang">
			<% @tag_g.each do |tag_group| %>
				<li ><a id="<%=tag_group.id %>" href="#" class="linkLang" title="Mostra linguagem"> #<%= tag_group.name %> </a></li>
			<%end%>
		</ul>
	</div>
		  <h1 id="logoPP" >
			  <a href="./" title="retornar a pagina principal"><span>Programador Poliglota</span></a>
      </h1><!-- logo site-->
    </div>
  </div>
  <div id="contentWrap">
    <%= yield %>
  </div>

<div id="footerWrap">
	<div id="footerPP" class="size1">
		
		<ul id="menuFooter">
	      <li><a id="menuFooterHomePP" href="<%= root_url %>"><span>Programador <br /> Poliglota</span></a></li>
	      <li><a id="menuFooterApoiePP" href="<%= support_url %>"><span>Apoie o <br /> movimento</span></a></li>
		</ul>
		
		<div id="socialFooter">
			<p><span>Siga essa causa:</span>
				<a id="twitterFooter" href="http://www.twitter.com/progpoliglota" target="_blank"> <span>@progpoliglota</span></a>
				<iframe src="http://www.facebook.com/plugins/like.php?href=www.programadorpoliglota.com.br&amp;layout=button_count&amp;show_faces=true&amp;width=450&amp;action=like&amp;colorscheme=light&amp;height=100" scrolling="no" frameborder="0" style="border:none; overflow:hidden; width:450px; height:21px;" allowTransparency="true"></iframe>
			</p>
		</div><!-- social icons-->
		
	</div><!-- footerPP-->	
<script type="text/javascript">

var _gaq = _gaq || [];
 _gaq.push(['_setAccount', 'UA-18141997-1']);
 _gaq.push(['_trackPageview']);

 (function() {
   var ga = document.createElement('script'); ga.type =
'text/javascript'; ga.async = true;
   ga.src = ('https:' == document.location.protocol ? 'https://ssl' :
'http://www') + '.google-analytics.com/ga.js';
   var s = document.getElementsByTagName('script')[0];
s.parentNode.insertBefore(ga, s);
 })();

</script>
</body>
</html>